%global gem_name logstasher

Name:           rubygem-%{gem_name}
Version:        0.5.3
Release:        0%{?dist}.3
Summary:        Awesome rails logs

Group:          Development/Languages
#
# License text not included in upstream source codes. For Fedora package chosen
# the "expat" variant text from http://opensource.org/licenses/MIT and upstream
# notified.
#
# https://github.com/shadabahmed/logstasher/issues/43
#
License:        MIT
URL:            https://github.com/shadabahmed/logstasher
Source0:        https://rubygems.org/gems/%{gem_name}-%{version}.gem
# https://github.com/shadabahmed/logstasher/issues/43
Source1:        LICENSE
# bundler killer patch
# (not intended for upstream)
Patch0:         logstasher-tests-unbundle.diff
# fix tests on Fedora
# https://github.com/shadabahmed/logstasher/pull/42
Patch1:         logstasher-tests-gemdir.diff
# compatibility with logstash-event >= 1.2
# (not intended for upstream)
Patch2:         logstasher-tests-time-ruby20.diff
Patch3:         logstasher-tests-time-ruby21.diff

BuildArch:      noarch
BuildRequires:  rubygems-devel
%if ! 0%{?rhel}
# more strict version for build - slight different output time in tests
BuildRequires:  rubygem(logstash-event) => 1.2
BuildRequires:  rubygem(rails) >= 3.0
BuildRequires:  rubygem(redis)
BuildRequires:  rubygem(request_store)
BuildRequires:  rubygem(rspec)
%endif
#Suggests:       rubygem(rails) >= 3.0
#Suggests:       rubygem(redis)
%if 0%{?fedora} && 0%{?fedora} <= 20 || 0%{?rhel} && 0%{?rhel} <= 7
Requires:       ruby(release)
Requires:       ruby(rubygems)
Requires:       rubygem(logstash-event) => 1.1.0
Requires:       rubygem(request_store)
Provides:       rubygem(%{gem_name}) = %{version}
%endif

%description
Awesome rails logs.


%package doc
Summary:        Documentation for %{name}
Group:          Documentation
BuildArch:      noarch
Requires:       %{name} = %{version}-%{release}

%description doc
Documentation for %{name}.


%prep
gem unpack %{SOURCE0}

%setup -q -D -T -n  %{gem_name}-%{version}
%patch0 -p1
%patch1 -p1
%if 0%{?fedora} && 0%{?fedora} <= 20 || 0%{?rhel} && 0%{?rhel} <= 7
%patch2 -p1
%else
%patch3 -p1
%endif

gem spec %{SOURCE0} -l --ruby > %{gem_name}.gemspec

# Remove < 1.2 restriction for logstash-event
# (requires the patch in tests)
sed -i -e 's|\(%q<logstash-event>,\) \[.*\]|\1 [">= 1.1.0"]|' %{gem_name}.gemspec

# Remove developer-only files
for f in .gitignore .rspec .travis.yml Gemfile Guardfile Rakefile; do
  rm $f
  sed -i "s|\"$f\",\?||g" %{gem_name}.gemspec
done


%build
# Create the gem as gem install only works on a gem file
gem build %{gem_name}.gemspec

# %%gem_install compiles any C extensions and installs the gem into ./%%gem_dir
# by default, so that we can move it into the buildroot in %%install
%gem_install


%install
mkdir -p %{buildroot}%{gem_dir}
cp -a .%{gem_dir}/* \
        %{buildroot}%{gem_dir}/

cp -p %{SOURCE1} %{buildroot}%{gem_instdir}/


%check
%if ! 0%{?rhel}
pushd .%{gem_instdir}
rspec -Ilib -Ispec spec
popd
%endif


%files
%doc %{gem_instdir}/LICENSE
%dir %{gem_instdir}
%{gem_libdir}/
%exclude %{gem_cache}
%{gem_spec}
%exclude %{gem_instdir}/%{gem_name}.gemspec

%files doc
%doc %{gem_docdir}
%{gem_instdir}/README.md
%{gem_instdir}/sample_logstash_configurations/
%{gem_instdir}/spec/


%changelog
* Tue Aug 19 2014 František Dvořák <valtri@civ.zcu.cz> - 0.5.3-0
- Initial package
